diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index 6fc2ba75e..909c71149 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -14,17 +14,20 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class BlockLeavesBase extends Block
+public class BlockLogicLeavesBase extends BlockLogic
 {
     public static final int MASK_DECAY_DATA = 0b0000_1111;
     public static final int NUM_DECAY_BITS = 4;
     public static final int DECAY_FLAG_BIT = 3;
     public static final int PERMANENT_FLAG_BIT = 0;
 
-	public BlockLeavesBase(String key, String namespaceId, int id, Material material)
+    protected Block<?> sapling;
+
+	public BlockLogicLeavesBase(Block<?> block, Material material, Block<?> sapling)
     {
-        super(key, namespaceId, id, material);
-        setTicking(true);
+        super(block, material);
+        block.setTicking(true);
+        this.sapling = sapling;
     }
 
     @Override
@@ -39,7 +42,7 @@ public abstract class BlockLeavesBase extends Block
 
         Season season = world.getSeasonManager().getCurrentSeason();
         float dropRate = season != null ? 20 / season.saplingDropFactor : 20;
-        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
+        if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(block) };
 
         int numDropped = 1;
 
@@ -48,7 +51,9 @@ public abstract class BlockLeavesBase extends Block
         return new ItemStack[] { new ItemStack(getSapling(), numDropped) };
     }
 
-    protected abstract Block getSapling();
+    protected Block<?> getSapling() {
+        return sapling;
+    }
     
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
@@ -67,8 +72,8 @@ public abstract class BlockLeavesBase extends Block
                 {
                     for(int dz = -radius; dz <= radius; dz++)
                     {
-                        int blockId = world.getBlockId(x + dx, y + dy, z + dz);
-                        if(Blocks.blocksList[blockId] instanceof BlockLeavesBase)
+                        Block<?> block = world.getBlock(x + dx, y + dy, z + dz);
+                        if(block != null && block.getLogic() instanceof BlockLogicLeavesBase)
                         {
                             int meta = world.getBlockMetadata(x + dx, y + dy, z + dz);
                             if (!isPermanent(meta))
@@ -108,13 +113,13 @@ public abstract class BlockLeavesBase extends Block
                     {
                         for(int zOffset = -byte0; zOffset <= byte0; zOffset++)
                         {
-                            int k3 = world.getBlockId(x + xOffset, y + yOffset, z + zOffset);
-                            if(Blocks.blocksList[k3] instanceof BlockLog)
+                            Block<?> block = world.getBlock(x + xOffset, y + yOffset, z + zOffset);
+                            if(block != null && block.getLogic() instanceof BlockLogicLog)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = 0;
                                 continue;
                             }
-                            if(Blocks.blocksList[k3] instanceof BlockLeavesBase)
+                            if(block != null && block.getLogic() instanceof BlockLogicLeavesBase)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = -2;
                             } else
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index ae27a6f24..6314b44be 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -18,14 +18,14 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
+public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBonemealable {
 
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 4;
     static final int BEAN_GROWTH_RATE = 50;
-    public BlockLeavesCacao(String key, String namespaceId, int id) {
-        super(key, namespaceId, id, Material.leaves);
-        setTicking(true);
+    public BlockLogicLeavesCacao(Block<?> block) {
+        super(block, Material.leaves, Blocks.SAPLING_CACAO);
+        block.setTicking(true);
     }
 
     public boolean canBeansGrow(World world, int x, int y, int z){
@@ -77,7 +77,7 @@ public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
             world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
-            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id(), tickDelay());
             return true;
         }
         return false;
@@ -98,22 +98,17 @@ public class BlockLeavesCacao extends BlockLeavesBase implements IBonemealable {
                 if (canBeansGrow(world, x, y, z)) {
                     if (growthRate < MAX_GROWTH_STATE) {
                         world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, ++growthRate));
-                        world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
+                        world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id(), tickDelay());
                     }
                 }
             }
             else if(growthRate > 0){
                 world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
-                world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
+                world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id(), tickDelay());
             }
         }
     }
 
-    @Override
-    protected Block getSapling() {
-        return Blocks.SAPLING_CACAO;
-    }
-
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
similarity index 68%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
index 7586cca01..7002bb67e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherry.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.season.Seasons;
 
 import java.util.Random;
 
-public class BlockLeavesCherry extends BlockLeavesBase
+public class BlockLogicLeavesCherry extends BlockLogicLeavesBase
 {
 
-	public BlockLeavesCherry(String key, String namespaceId, int id)
+	public BlockLogicLeavesCherry(Block<?> block)
     {
-        super(key, namespaceId, id, Material.leaves);
+        super(block, Material.leaves, Blocks.SAPLING_CHERRY);
     }
 
     @Override
@@ -23,9 +23,4 @@ public class BlockLeavesCherry extends BlockLeavesBase
         }
     }
 
-    @Override
-    protected Block getSapling()
-    {
-        return Blocks.SAPLING_CHERRY;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
similarity index 93%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index 6d991b53d..9bf773bc7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -15,12 +15,12 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBonemealable
+public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry implements IBonemealable
 {
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 1;
-	public BlockLeavesCherryFlowering(String key, String namespaceId, int id) {
-        super(key, namespaceId, id);
+	public BlockLogicLeavesCherryFlowering(Block<?> block) {
+        super(block);
     }
 
     @Override
@@ -61,7 +61,7 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
             world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
-            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
             return true;
         }
         return false;
@@ -82,13 +82,13 @@ public class BlockLeavesCherryFlowering extends BlockLeavesCherry implements IBo
             if (rand.nextInt(20) == 0) {
                 if ((growthRate) == 0) {
                     world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, MAX_GROWTH_STATE));
-                    world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
+                    world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
                 }
             }
         }
        else if(growthRate > 0){
             world.setBlockMetadataWithNotify(x, y, z, meta & MASK_DECAY_DATA);
-            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
similarity index 64%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
index 90c2efb10..6ad966948 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesEucalyptus.java
@@ -5,18 +5,12 @@ import net.minecraft.core.block.material.Material;
 
 import java.util.Random;
 
-public class BlockLeavesEucalyptus extends BlockLeavesBase
+public class BlockLogicLeavesEucalyptus extends BlockLogicLeavesBase
 {
 
-	public BlockLeavesEucalyptus(String key, String namespaceId, int id)
+	public BlockLogicLeavesEucalyptus(Block<?> block)
     {
-        super(key, namespaceId, id, Material.leaves);
-    }
-
-    @Override
-    protected Block getSapling()
-    {
-        return Blocks.SAPLING_EUCALYPTUS;
+        super(block, Material.leaves, Blocks.SAPLING_EUCALYPTUS);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
index e446d3bdd..699fc0242 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
@@ -6,11 +6,11 @@ import net.minecraft.core.world.wind.WindProvider;
 
 import java.util.Random;
 
-public class BlockLeavesOak extends BlockLeavesBase
+public class BlockLogicLeavesOak extends BlockLogicLeavesBase
 {
-	public BlockLeavesOak(String key, String namespaceId, int id)
+	public BlockLogicLeavesOak(Block<?> block)
     {
-        super(key, namespaceId, id, Material.leaves);
+        super(block, Material.leaves, Blocks.SAPLING_OAK);
     }
 
     @Override
@@ -23,26 +23,20 @@ public class BlockLeavesOak extends BlockLeavesBase
             {
                 int id = world.getBlockId(x, y + q, z);
                 if (id != 0) break;
-                if (Blocks.LAYER_LEAVES_OAK.canPlaceBlockAt(world, x, y + q, z) && Blocks.blocksList[world.getBlockId(x, y + q - 1, z)].blockMaterial.blocksMotion())
+                if (Blocks.LAYER_LEAVES_OAK.canPlaceBlockAt(world, x, y + q, z) && Blocks.blocksList[world.getBlockId(x, y + q - 1, z)].getMaterial().blocksMotion())
                 {
-                    world.setBlockWithNotify(x, y + q, z, Blocks.LAYER_LEAVES_OAK.id);
+                    world.setBlockWithNotify(x, y + q, z, Blocks.LAYER_LEAVES_OAK.id());
                     break;
                 }
-                else if (world.getBlockId(x, y + q, z) == Blocks.LAYER_LEAVES_OAK.id)
+                else if (world.getBlockId(x, y + q, z) == Blocks.LAYER_LEAVES_OAK.id())
                 {
-                    ((BlockLayerLeaves) Blocks.LAYER_LEAVES_OAK).accumulate(world, x, y + q, z);
+                    Blocks.LAYER_LEAVES_OAK.getLogic().accumulate(world, x, y + q, z);
                     break;
                 }
             }
         }
     }
 
-    @Override
-    protected Block getSapling()
-    {
-        return Blocks.SAPLING_OAK;
-    }
-
     @Override
     public void animationTick(World world, int x, int y, int z, Random rand)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesPine.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
index 91102df67..5d0398f43 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesPine.java
@@ -6,12 +6,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class BlockLeavesPine extends BlockLeavesBase
+public class BlockLogicLeavesPine extends BlockLogicLeavesBase
 {
 
-	public BlockLeavesPine(String key, String namespaceId, int id)
+	public BlockLogicLeavesPine(Block<?> block)
     {
-        super(key, namespaceId, id, Material.leaves);
+        super(block, Material.leaves, Blocks.SAPLING_PINE);
     }
 
     @Override
@@ -26,9 +26,4 @@ public class BlockLeavesPine extends BlockLeavesBase
         return new ItemStack[] { new ItemStack(getSapling(), numDropped) };
     }
 
-    @Override
-    protected Block getSapling()
-    {
-        return Blocks.SAPLING_PINE;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
similarity index 66%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
index 92b3f9e93..d145488a7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesShrub.java
@@ -5,18 +5,12 @@ import net.minecraft.core.block.material.Material;
 
 import java.util.Random;
 
-public class BlockLeavesShrub extends BlockLeavesBase
+public class BlockLogicLeavesShrub extends BlockLogicLeavesBase
 {
 
-	public BlockLeavesShrub(String key, String namespaceId, int id)
+	public BlockLogicLeavesShrub(Block<?> block)
     {
-        super(key, namespaceId, id, Material.leaves);
-    }
-
-    @Override
-    protected Block getSapling()
-    {
-        return Blocks.SAPLING_SHRUB;
+        super(block, Material.leaves, Blocks.SAPLING_SHRUB);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
similarity index 94%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLever.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index dd455cbb6..f621491c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -17,7 +17,7 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLever extends Block
+public class BlockLogicLever extends BlockLogic
 {
     public static final int MASK_POWERED = 0b0001_0000;
     public static final int MASK_ROTATION = 0b0000_1111;
@@ -30,9 +30,9 @@ public class BlockLever extends Block
     public static final int ROTATION_BOTTOM_NS = 7;
     public static final int ROTATION_BOTTOM_WE = 8;
 
-	public BlockLever(String key, String namespaceId, int id)
+	public BlockLogicLever(Block<?> block)
     {
-        super(key, namespaceId, id, Material.decoration);
+        super(block, Material.decoration);
     }
 
     @Override
@@ -265,19 +265,19 @@ public class BlockLever extends Block
 
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
-        world.notifyBlocksOfNeighborChange(x, y, z, id);
+        world.notifyBlocksOfNeighborChange(x, y, z, block.id());
         if(rotation == ROTATION_EAST) {
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, block.id());
         } else if(rotation == ROTATION_WEST) {
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, block.id());
         } else if(rotation == ROTATION_SOUTH) {
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, block.id());
         } else if(rotation == ROTATION_NORTH) {
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, block.id());
         } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE){
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, block.id());
         } else {
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, block.id());
         }
     }
 
@@ -291,20 +291,20 @@ public class BlockLever extends Block
     {
         if(isPowered(data))
         {
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, block.id());
             int rotation = getRotation(data);
             if(rotation == ROTATION_EAST) {
-                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, block.id());
             } else if(rotation == ROTATION_WEST) {
-                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, block.id());
             } else if(rotation == ROTATION_SOUTH) {
-                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, block.id());
             } else if(rotation == ROTATION_NORTH) {
-                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, block.id());
             } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE){
-                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, block.id());
             } else {
-                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, block.id());
             }
         }
         super.onBlockRemoved(world, x, y, z, data);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
similarity index 67%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLog.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
index 02df9bd44..ba90139c3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
@@ -3,12 +3,12 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockLog extends BlockAxisAligned
+public class BlockLogicLog extends BlockLogicAxisAligned
 {
 
-	public BlockLog(String key, String namespaceId, int id)
+	public BlockLogicLog(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
     }
 
     @Override
@@ -24,15 +24,15 @@ public class BlockLog extends BlockAxisAligned
                 {
                     for(int _z = -r; _z <= r; _z++)
                     {
-                        int l1 = world.getBlockId(x + _x, y + _y, z + _z);
-                        if(!(Blocks.blocksList[l1] instanceof BlockLeavesBase))
+                        Block<?> block = world.getBlock(x + _x, y + _y, z + _z);
+                        if(!(block != null && block.getLogic() instanceof BlockLogicLeavesBase))
                         {
                             continue;
                         }
                         int leavesMeta = world.getBlockMetadata(x + _x, y + _y, z + _z);
-                        if(!BlockLeavesBase.isPermanent(leavesMeta))
+                        if(!BlockLogicLeavesBase.isPermanent(leavesMeta))
                         {
-                            world.setBlockMetadata(x + _x, y + _y, z + _z, BlockLeavesBase.setDecaying(leavesMeta, true));
+                            world.setBlockMetadata(x + _x, y + _y, z + _z, BlockLogicLeavesBase.setDecaying(leavesMeta, true));
                         }
                     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMesh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMesh.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
index b3234266a..614f7d8ec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
@@ -5,12 +5,12 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.world.World;
 
-public class BlockMesh extends BlockTransparent
+public class BlockLogicMesh extends BlockLogicTransparent
 {
 
-    public BlockMesh(String key, String namespaceId, int id)
+    public BlockLogicMesh(Block<?> block)
     {
-        super(key, namespaceId, id, Material.metal);
+        super(block, Material.metal);
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
similarity index 68%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMeshGold.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index 70f09e2b5..d8468e00d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -1,8 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -10,31 +8,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockMeshGold extends BlockTileEntity {
-    public BlockMeshGold(String key, String namespaceId, int id) {
-        super(key, namespaceId, id, Material.metal);
+public class BlockLogicMeshGold extends BlockLogicMesh {
+    public BlockLogicMeshGold(Block<?> block) {
+        super(block);
+        block.withEntity(TileEntityMeshGold::new);
     }
 
-    @Override
-    protected TileEntity getNewBlockEntity() {
-        return new TileEntityMeshGold();
-    }
-    @Override
-    public boolean isSolidRender()
-    {
-        return false;
-    }
-    @Override
-    public boolean isCubeShaped()
-    {
-        return false;
-    }
-
-    @Override
-    public boolean canPlaceOnSurface()
-    {
-        return true;
-    }
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index f3ca1073d..b586c93e1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -2,8 +2,6 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -14,12 +12,13 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockMobSpawner extends BlockTileEntity
+public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
 {
 
-	public BlockMobSpawner(String key, String namespaceId, int id)
+	public BlockLogicMobSpawner(Block<?> block)
     {
-        super(key, namespaceId, id, Material.stone);
+        super(block);
+        block.withEntity(TileEntityMobSpawner::new);
     }
 
     @Override
@@ -32,22 +31,12 @@ public class BlockMobSpawner extends BlockTileEntity
         return true;
     }
 
-    @Override
-	public TileEntity getNewBlockEntity()
-    {
-        return new TileEntityMobSpawner();
-    }
-
     @Override
 	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
     	TileEntityMobSpawner tileEntity = (TileEntityMobSpawner) world.getBlockEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
 
-    @Override
-    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof EntityItem);
-    }
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
@@ -61,22 +50,22 @@ public class BlockMobSpawner extends BlockTileEntity
                 if(mobInSpawner != null) {
                     ItemStack itemstack;
                     switch (mobInSpawner) {
-                        case "Zombie":
+                        case "minecraft:zombie":
                             itemstack = new ItemStack(Items.CLOTH);
                             break;
-                        case "Skeleton":
+                        case "minecraft:skeleton":
                             if (world.rand.nextInt(2) == 0)
                                 itemstack = new ItemStack(Items.BONE);
                             else
                                 itemstack = new ItemStack(Items.AMMO_ARROW);
                             break;
-                        case "ArmouredZombie":
+                        case "minecraft:zombie_armored":
                             itemstack = new ItemStack(Items.CHAINLINK);
                             break;
-                        case "Spider":
+                        case "minecraft:spider":
                             itemstack = new ItemStack(Items.STRING);
                             break;
-                        case "Snowman":
+                        case "minecraft:snowman":
                             itemstack = new ItemStack(Items.AMMO_SNOWBALL);
                             break;
                         default:
@@ -121,15 +110,4 @@ public class BlockMobSpawner extends BlockTileEntity
         }
         return null;
     }
-
-    @Override
-	public boolean isSolidRender()
-    {
-        return false;
-    }
-    
-    @Override
-	public boolean isCubeShaped() {
-    	return false;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
index ec0bbf5b5..faa6eefdf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
@@ -8,10 +8,10 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockMobSpawnerDeactivated extends BlockTransparent {
-    public BlockMobSpawnerDeactivated(String key, String namespaceId, int id, Material material)
+public class BlockLogicMobSpawnerDeactivated extends BlockLogicTransparent {
+    public BlockLogicMobSpawnerDeactivated(Block<?> block)
     {
-        super(key, namespaceId, id, material);
+        super(block, Material.stone);
     }
 
     @Override
